""" Function manglers for math functions in C++ """

from dune.perftool.generation import (function_mangler,
                                      include_file,
                                      )

from loopy import CallMangleInfo


@function_mangler
def dune_math_manglers(kernel, name, arg_dtypes):
    if name == "exp":
        include_file("dune/perftool/common/vectorclass.hh", filetag="operatorfile")
        return CallMangleInfo("exp",
                              arg_dtypes,
                              arg_dtypes,
                              )

    if name == "sqrt":
        return CallMangleInfo("sqrt",
                              arg_dtypes,
                              arg_dtypes,
                              )
